#ifndef __CONFIG_H__
#define	__CONFIG_H__

#include <iconv.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

#define OPT_DEBUG		0
#define OPT_SMB_MAX_DESCR	1
#define	OPT_REFRESH_TIME	2
#define	OPT_DEAD_TIME		3
#define OPT_BLOCK_SIZE		4
#define	OPT_QUIET_FLAG		5
#define OPT_QUERY_BROWSERS	6

struct option{
    int		debug;		// smbclient debug level
    int		smb_descr_max;	// maximum smbccontexts number
    int		refresh_time;	// workgroup refresh time
    int		dead_time;	// dead time of computer/workgroup
    int		block_size;	// maximum IO block size
    int		quiet_flag;	// ignore chown/chgroup error
    int		query_browsers;	// query samba master browsers or no  
    char	*username;	// default samba username
    char	*password;	// default samba password
    char	*local_charset;	// system charset
    char	*samba_charset;	// samba internal charset
    char	*log_file;	// log file
};

extern char	*config;

char*	alloc_string(char *value);
int	get_number(char *value);
int	get_boolean(char *value);
void	create_defaults();
int	set_option(struct option *opt, char *name, char *value);
void	init_option(struct option *opt);
void	destroy_option(struct option *opt);
void	check_option(struct option *opt);

int	option(int opt);
void	set_all_option(struct option *opt);
iconv_t	local2samba();
iconv_t samba2local();
void	fill_login_info(char *user, int userlen, char *passwd, int passwdlen);

void	debug_print(const char *fmt, ...);

#define	DPRINT(fmt, args...)    debug_print("%d->%s: " fmt, getpid(), __FUNCTION__, ## args)

#endif /* __CONFIG_H__ */
