#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <wchar.h>
#include "config.h"
#include "convert.h"

int ConvertFromSambaAllocSize(int strlen){
    return strlen + 1;
}

int ConvertToSambaAllocSize(int strlen){
    return (strlen + 1) * sizeof(wchar_t);
}

int convert(iconv_t cd, char *from, size_t from_len, char *to, size_t to_len){
    memset(to, 0, to_len); to_len--;    

    while( (from_len > 0) && (to_len > 0) ){
	if (cd != (iconv_t)(-1)){
	    size_t res = iconv(cd, &from, &from_len, &to, &to_len);
	    iconv(cd, NULL, NULL, NULL, NULL);
	    if (res != (size_t)(-1)) return 1;
	}
	*to++ = *from++; from_len--; to_len--;
    }
    return 0;
}

const char* path2samba(const char *path){
    iconv_t	cd;
    int		alloc_size;
    char	*smbpath;

    // find paths first component position 
    for( ; *path; path++) if (*path != '/') break;

    alloc_size = ConvertToSambaAllocSize(strlen(path));
    if ((smbpath = (char*)malloc(alloc_size + 6)) == NULL) return NULL;
    memset(smbpath, 0, alloc_size + 6);

    strcpy(smbpath, "smb://");
    cd = local2samba();
    convert(cd, (char*)path, strlen(path), smbpath + 6, alloc_size);
    iconv_close(cd);
    return smbpath;
}

const char* from_samba(const char *samba_name, iconv_t cd){
    int		alloc_size;
    char	*name;

    alloc_size = ConvertFromSambaAllocSize(strlen(samba_name));
    if ((name = (char*)malloc(alloc_size)) == NULL) return NULL;
    memset(name, 0, alloc_size);
    convert(cd, (char*)samba_name, strlen(samba_name), name, alloc_size);

    return name;
}
