#ifndef __SMBDESCR_H__
#define __SMBDESCR_H__

#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <libsmbclient.h>

struct SmbDescriptor{
    struct SmbDescriptor  *next;
    struct SmbDescriptor  *prev;
    SMBCCTX		  *ctx;
    SMBCFILE		  *fd;
    off_t		  offset;
    int			  error;
    char		  name[0];
};

struct SmbDescriptor* GetSmbDescriptor(const char *name, int name_len);
void		      CleanupSmbDescriptor(struct SmbDescriptor *descr);
void		      ReleaseSmbDescriptor(struct SmbDescriptor *descr);  
void        	      DestroySmbDescriptorList();

#endif	/* __SMBDESCR_H__ */
