#ifndef __SMBITEM_H__
#define __SMBITEM_H__

#include <time.h>

#define USERPATH	0x01
#define AUTOPATH	0x02

#define SMBITEM_LINK	0
#define SMBITEM_COMP	1
#define SMBITEM_GROUP	2

#define PATH_UNKNOWN		-1
#define PATH_TO_DIR		0
#define PATH_TO_LINK		1
#define PATH_TO_COMP		2
#define PATH_TO_SHARE		3
#define PATH_TO_SMBFILE		4

struct smbitem{
    int			type;		// item type: comp/link/group
    const char		*name;		// item name
    time_t		ctime;		// item creation time
    int			ref_count;	// the number of item references
    char		data[0];
};

struct smbitemarray{
    int			count;
    int			max_count;
    struct smbitem	**elem;
};

int			mkgroup(char *path, int flag);
int			mkhost(char *path, int flag);
int			mklink(char *path, char *link, int flag);

struct smbitemarray*	getdir(char *path, int flag);
void			ReleaseSmbItemArray(struct smbitemarray *array);
void			ReleaseOldItem(time_t ctime, int flag);

int			FindSlash(const char *path);
int			GetPathComponent(const char *path);
const char*		GetFirstPath(const char* path, int *result_len);
const char*		GetSecondPath(const char* path, int *result_len);

int			GetPathType(const char *path, void **data);

#endif /* __SMBITEM_H__ */
